! *******************************************************************
! * FILELENGTH ERMITTELT DIE LAENGE DES ANGEGEBENEN FILES UND GIBT  *
! *                           SIE ZURCK !                          *
! *      DIESE PROZEDUR FUNKTIONIERT FUER ALLE DATEIENTYPEN !       *
! *    !! DIESES INCLUDE-FILE IST NUR FUER DAS MODULE SYSTEM !!     *
! *!! FUER DEN HTTP-DAEMON IST DAS INCLUDE-FILE FILELENG.INC  !!    *
! *-----------------------------------------------------------------*
! * BENOETIGTE PROGRAMME / INCLUDE-FILES : FILEERR.INC              *
! *                                        NETLNK.SR                *
! *                                                                 *
! *                                                                 *
! *                                                                 *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 05.05.1998                                   *
! * LETZTE AENDERUNG : 20.04.1999                                   *
! *******************************************************************
 FILELENGTH: PROC( FILENAME CHAR(255) IDENT,
                   CONTENT_TYPE CHAR(255) IDENT,
                   METHOD_OR_ERROR CHAR(255) IDENT,
                   stdout DATION INOUT ALPHIC IDENT,
                   stderr DATION INOUT ALPHIC IDENT,
                   file2  DATION INOUT ALPHIC IDENT,
                   loglink DATION OUT ALPHIC IDENT
                 ) RETURNS(FIXED(31));
    
    DCL FILESTATE            FIXED(15)    INIT(0);
    DCL LAENGE               FIXED(31)    INIT(0);
     
    OPEN file2 BY IDF(FILENAME),OLD;
    FILESTATE:=ST(file2);
    IF (FILESTATE NE 0) THEN
       #IF MINILOG+MAXILOG 
           PUT 'Ax: FILELENGTH : unable to open file ',FILENAME
                TO loglink BY A,A(LEN(FILENAME));
       #FIN; 
       PUT 'HTTP-User: FILELENGTH : KONNTE DATEI ',FILENAME,
           ' NICHT OEFFNEN !' TO 
           stderr BY A,A(LEN(FILENAME)),A,SKIP;
    FIN;    
    
    IF (FILESTATE == 0) THEN

       APPEND(file2);
       SAVEP(file2,LAENGE);  

       CLOSE file2;
       FILESTATE:=ST(file2);
       IF (FILESTATE NE 0) THEN
          PUT 'FILELENGTH : KONNTE DATEI ',FILENAME,
              ' NICHT SCHLIESSEN !' TO 
              stdout BY A,A(LEN(FILENAME)),A,SKIP;
          PUT 'SYSTEM- FEHLER : ',FILESTATE TO stdout BY SKIP,A,F(3);
          FileErr(FILESTATE,stdout);
          #IF MAXILOG+MINILOG 
              PUT 'Ax: FILELENGTH : unable to close file ',FILENAME
                  TO loglink  BY A,A(LEN(FILENAME));
              PUT 'Ax: File-error #',FILESTATE TO loglink BY A,F(3);
              FileErr(FILESTATE,loglink);
          #FIN; 
       FIN;   
    ELSE /* IF FILESTATE == 0 THEN */
       PUT 'FILELENGTH : KONNTE DATEI ',FILENAME,' NICHT OEFFNEN !'
           TO stdout BY A,A(LEN(FILENAME)),A,SKIP;
       PUT 'SYSTEM- FEHLER : ',FILESTATE TO stdout BY SKIP,A,F(3);
       FileErr(FILESTATE,stdout);
       #IF MAXILOG+MINILOG 
           PUT 'Ax: FILELENGTH : Unable to open file ',FILENAME
               TO loglink BY A,A(LEN(FILENAME));
           PUT 'Ax: File-error #',FILESTATE TO loglink BY A,F(3);
           FileErr(FILESTATE,loglink);
       #FIN; 
    FIN; /* IF (FILESTATE == 0) THEN */

    #IF MAXILOG 
        PUT 'Ax: FILELENG : FILENAME : ',FILENAME TO 
            loglink BY A,A(LEN(FILENAME));
        PUT 'Ax: FILESIZE            : ',LAENGE TO 
            loglink BY A,F(10);
    #FIN; 

    RETURN(LAENGE);
 END; /*FILELENGTH*/
